/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "earth_options.h"

static int EarthOptionsDisplayPrivateIndex;

static CompMetadata earthOptionsMetadata;

static CompPluginVTable *earthPluginVTable = NULL;
CompPluginVTable earthOptionsVTable;

#define EARTH_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, EarthOptions, o)
#define EARTH_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, EarthOptions, o)

typedef struct _EarthOptionsDisplay
{
    int screenPrivateIndex;

} EarthOptionsDisplay;

typedef struct _EarthOptionsScreen
{
    CompOption opt[EarthScreenOptionNum];
    earthScreenOptionChangeNotifyProc notify[EarthScreenOptionNum];
} EarthOptionsScreen;

float earthGetLatitude (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionLatitude].value.f;
}

CompOption * earthGetLatitudeOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionLatitude];
}

void earthSetLatitudeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionLatitude] = notify;
}

float earthGetLongitude (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionLongitude].value.f;
}

CompOption * earthGetLongitudeOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionLongitude];
}

void earthSetLongitudeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionLongitude] = notify;
}

float earthGetTimezone (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionTimezone].value.f;
}

CompOption * earthGetTimezoneOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionTimezone];
}

void earthSetTimezoneNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionTimezone] = notify;
}

Bool earthGetShaders (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionShaders].value.b;
}

CompOption * earthGetShadersOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionShaders];
}

void earthSetShadersNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionShaders] = notify;
}

Bool earthGetClouds (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionClouds].value.b;
}

CompOption * earthGetCloudsOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionClouds];
}

void earthSetCloudsNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionClouds] = notify;
}

float earthGetRotation (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionRotation].value.f;
}

CompOption * earthGetRotationOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionRotation];
}

void earthSetRotationNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionRotation] = notify;
}

char * earthGetCloudsUrl (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionCloudsUrl].value.s;
}

CompOption * earthGetCloudsUrlOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionCloudsUrl];
}

void earthSetCloudsUrlNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionCloudsUrl] = notify;
}

float earthGetEarthSize (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return os->opt[EarthScreenOptionEarthSize].value.f;
}

CompOption * earthGetEarthSizeOption (CompScreen *s)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[EarthScreenOptionEarthSize];
}

void earthSetEarthSizeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify)
{
    EARTH_OPTIONS_SCREEN(s);
    os->notify[EarthScreenOptionEarthSize] = notify;
}

CompOption * earthGetScreenOption (CompScreen *s, EarthScreenOptions num)
{
    EARTH_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo earthOptionsScreenOptionInfo[] = {
    { "latitude", "float", "<min>-180</min><max>180</max>", 0, 0 },
    { "longitude", "float", "<min>-180</min><max>180</max>", 0, 0 },
    { "timezone", "float", "<min>-12</min><max>12</max>", 0, 0 },
    { "shaders", "bool", 0, 0, 0 },
    { "clouds", "bool", 0, 0, 0 },
    { "rotation", "float", "<min>-1</min><max>1</max>", 0, 0 },
    { "clouds_url", "string", 0, 0, 0 },
    { "earth_size", "float", "<min>0.1</min><max>1</max>", 0, 0 },
};

static Bool earthOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    EARTH_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, EarthScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case EarthScreenOptionLatitude:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionLatitude])
                (*os->notify[EarthScreenOptionLatitude]) (s, o, EarthScreenOptionLatitude);
            return TRUE;
        }
        break;
     case EarthScreenOptionLongitude:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionLongitude])
                (*os->notify[EarthScreenOptionLongitude]) (s, o, EarthScreenOptionLongitude);
            return TRUE;
        }
        break;
     case EarthScreenOptionTimezone:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionTimezone])
                (*os->notify[EarthScreenOptionTimezone]) (s, o, EarthScreenOptionTimezone);
            return TRUE;
        }
        break;
     case EarthScreenOptionShaders:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionShaders])
                (*os->notify[EarthScreenOptionShaders]) (s, o, EarthScreenOptionShaders);
            return TRUE;
        }
        break;
     case EarthScreenOptionClouds:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionClouds])
                (*os->notify[EarthScreenOptionClouds]) (s, o, EarthScreenOptionClouds);
            return TRUE;
        }
        break;
     case EarthScreenOptionRotation:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionRotation])
                (*os->notify[EarthScreenOptionRotation]) (s, o, EarthScreenOptionRotation);
            return TRUE;
        }
        break;
     case EarthScreenOptionCloudsUrl:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionCloudsUrl])
                (*os->notify[EarthScreenOptionCloudsUrl]) (s, o, EarthScreenOptionCloudsUrl);
            return TRUE;
        }
        break;
     case EarthScreenOptionEarthSize:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[EarthScreenOptionEarthSize])
                (*os->notify[EarthScreenOptionEarthSize]) (s, o, EarthScreenOptionEarthSize);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * earthOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    EARTH_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = EarthScreenOptionNum;
    return os->opt;
}

static Bool earthOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    EarthOptionsScreen *os;
    
    EARTH_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(EarthOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &earthOptionsMetadata, earthOptionsScreenOptionInfo, os->opt, EarthScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void earthOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    EARTH_OPTIONS_SCREEN (s);
    EARTH_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, EarthScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool earthOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    EarthOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(EarthOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[EarthOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void earthOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    EARTH_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[EarthOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool earthOptionsInit (CompPlugin *p)
{
    EarthOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (EarthOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&earthOptionsMetadata, "earth",0, 0, earthOptionsScreenOptionInfo, EarthScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&earthOptionsMetadata, "earth");
    if (earthPluginVTable && earthPluginVTable->init)
        return earthPluginVTable->init (p);
    return TRUE;
}

static void earthOptionsFini (CompPlugin *p)
{
    if (earthPluginVTable && earthPluginVTable->fini)
        earthPluginVTable->fini (p);

    if (EarthOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (EarthOptionsDisplayPrivateIndex);

    compFiniMetadata (&earthOptionsMetadata);
}

static CompBool earthOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) earthOptionsInitDisplay,
        (InitPluginObjectProc) earthOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void earthOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) earthOptionsFiniDisplay,
        (FiniPluginObjectProc) earthOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool earthOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = earthOptionsInitObject (p, o);
    if (earthPluginVTable->initObject)
        rv &= earthPluginVTable->initObject (p, o);
    return rv;
}

static void earthOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (earthPluginVTable->finiObject)
        earthPluginVTable->finiObject (p, o);
    earthOptionsFiniObject (p, o);
}

static CompOption * earthOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
        (GetPluginObjectOptionsProc) earthOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool earthOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) earthOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
earthOptionsGetMetadata (CompPlugin *plugin)
{
    return &earthOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!earthPluginVTable)
    {
        earthPluginVTable = getCompPluginInfo ();
        memcpy(&earthOptionsVTable, earthPluginVTable, sizeof(CompPluginVTable));
        earthOptionsVTable.getMetadata = earthOptionsGetMetadata;
        earthOptionsVTable.init = earthOptionsInit;
        earthOptionsVTable.fini = earthOptionsFini;
        earthOptionsVTable.initObject = earthOptionsInitObjectWrapper;
        earthOptionsVTable.finiObject = earthOptionsFiniObjectWrapper;
        earthOptionsVTable.getObjectOptions = earthOptionsGetObjectOptions;
	earthOptionsVTable.setObjectOption = earthOptionsSetObjectOption;
	
    }
    return &earthOptionsVTable;
}

