/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _EARTH_OPTIONS_H
#define _EARTH_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    EarthDisplayOptionNum
} EarthDisplayOptions;

typedef void (*earthDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, EarthDisplayOptions num);

CompOption *earthGetDisplayOption (CompDisplay *d, EarthDisplayOptions num);

typedef enum
{
    EarthScreenOptionLatitude,
    EarthScreenOptionLongitude,
    EarthScreenOptionTimezone,
    EarthScreenOptionShaders,
    EarthScreenOptionClouds,
    EarthScreenOptionRotation,
    EarthScreenOptionCloudsUrl,
    EarthScreenOptionEarthSize,
    EarthScreenOptionNum
} EarthScreenOptions;

typedef void (*earthScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, EarthScreenOptions num);

CompOption *earthGetScreenOption (CompScreen *s, EarthScreenOptions num);

float            earthGetLatitude (CompScreen *s);
CompOption *     earthGetLatitudeOption (CompScreen *s);
void             earthSetLatitudeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

float            earthGetLongitude (CompScreen *s);
CompOption *     earthGetLongitudeOption (CompScreen *s);
void             earthSetLongitudeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

float            earthGetTimezone (CompScreen *s);
CompOption *     earthGetTimezoneOption (CompScreen *s);
void             earthSetTimezoneNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

Bool             earthGetShaders (CompScreen *s);
CompOption *     earthGetShadersOption (CompScreen *s);
void             earthSetShadersNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

Bool             earthGetClouds (CompScreen *s);
CompOption *     earthGetCloudsOption (CompScreen *s);
void             earthSetCloudsNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

float            earthGetRotation (CompScreen *s);
CompOption *     earthGetRotationOption (CompScreen *s);
void             earthSetRotationNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

char *           earthGetCloudsUrl (CompScreen *s);
CompOption *     earthGetCloudsUrlOption (CompScreen *s);
void             earthSetCloudsUrlNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

float            earthGetEarthSize (CompScreen *s);
CompOption *     earthGetEarthSizeOption (CompScreen *s);
void             earthSetEarthSizeNotify (CompScreen *s, earthScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
